<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegisterChildInternetShop StructType
 * @subpackage Structs
 */
class RegisterChildInternetShop extends AbstractStructBase
{
    /**
     * The sorting
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $sorting;
    /**
     * The parentID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $parentID;
    /**
     * The shopName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $shopName;
    /**
     * The shopTitle
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $shopTitle;
    /**
     * The shopJurFace
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $shopJurFace;
    /**
     * The shopPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $shopPhone;
    /**
     * The textReceipt
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $textReceipt;
    /**
     * The receiverID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $receiverID;
    /**
     * The Auth
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Authentication
     */
    public $Auth;
    /**
     * The shopINN
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $shopINN;
    /**
     * The phoneForCheck
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $phoneForCheck;
    /**
     * Constructor method for RegisterChildInternetShop
     * @uses RegisterChildInternetShop::setSorting()
     * @uses RegisterChildInternetShop::setParentID()
     * @uses RegisterChildInternetShop::setShopName()
     * @uses RegisterChildInternetShop::setShopTitle()
     * @uses RegisterChildInternetShop::setShopJurFace()
     * @uses RegisterChildInternetShop::setShopPhone()
     * @uses RegisterChildInternetShop::setTextReceipt()
     * @uses RegisterChildInternetShop::setReceiverID()
     * @uses RegisterChildInternetShop::setAuth()
     * @uses RegisterChildInternetShop::setShopINN()
     * @uses RegisterChildInternetShop::setPhoneForCheck()
     * @param int $sorting
     * @param int $parentID
     * @param string $shopName
     * @param string $shopTitle
     * @param string $shopJurFace
     * @param string $shopPhone
     * @param string $textReceipt
     * @param string $receiverID
     * @param \StructType\Authentication $auth
     * @param string $shopINN
     * @param string $phoneForCheck
     */
    public function __construct($sorting = null, $parentID = null, $shopName = null, $shopTitle = null, $shopJurFace = null, $shopPhone = null, $textReceipt = null, $receiverID = null, \StructType\Authentication $auth = null, $shopINN = null, $phoneForCheck = null)
    {
        $this
            ->setSorting($sorting)
            ->setParentID($parentID)
            ->setShopName($shopName)
            ->setShopTitle($shopTitle)
            ->setShopJurFace($shopJurFace)
            ->setShopPhone($shopPhone)
            ->setTextReceipt($textReceipt)
            ->setReceiverID($receiverID)
            ->setAuth($auth)
            ->setShopINN($shopINN)
            ->setPhoneForCheck($phoneForCheck);
    }
    /**
     * Get sorting value
     * @return int
     */
    public function getSorting()
    {
        return $this->sorting;
    }
    /**
     * Set sorting value
     * @param int $sorting
     * @return \StructType\RegisterChildInternetShop
     */
    public function setSorting($sorting = null)
    {
        // validation for constraint: int
        if (!is_null($sorting) && !(is_int($sorting) || ctype_digit($sorting))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sorting, true), gettype($sorting)), __LINE__);
        }
        $this->sorting = $sorting;
        return $this;
    }
    /**
     * Get parentID value
     * @return int
     */
    public function getParentID()
    {
        return $this->parentID;
    }
    /**
     * Set parentID value
     * @param int $parentID
     * @return \StructType\RegisterChildInternetShop
     */
    public function setParentID($parentID = null)
    {
        // validation for constraint: int
        if (!is_null($parentID) && !(is_int($parentID) || ctype_digit($parentID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($parentID, true), gettype($parentID)), __LINE__);
        }
        $this->parentID = $parentID;
        return $this;
    }
    /**
     * Get shopName value
     * @return string|null
     */
    public function getShopName()
    {
        return $this->shopName;
    }
    /**
     * Set shopName value
     * @param string $shopName
     * @return \StructType\RegisterChildInternetShop
     */
    public function setShopName($shopName = null)
    {
        // validation for constraint: string
        if (!is_null($shopName) && !is_string($shopName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shopName, true), gettype($shopName)), __LINE__);
        }
        $this->shopName = $shopName;
        return $this;
    }
    /**
     * Get shopTitle value
     * @return string|null
     */
    public function getShopTitle()
    {
        return $this->shopTitle;
    }
    /**
     * Set shopTitle value
     * @param string $shopTitle
     * @return \StructType\RegisterChildInternetShop
     */
    public function setShopTitle($shopTitle = null)
    {
        // validation for constraint: string
        if (!is_null($shopTitle) && !is_string($shopTitle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shopTitle, true), gettype($shopTitle)), __LINE__);
        }
        $this->shopTitle = $shopTitle;
        return $this;
    }
    /**
     * Get shopJurFace value
     * @return string|null
     */
    public function getShopJurFace()
    {
        return $this->shopJurFace;
    }
    /**
     * Set shopJurFace value
     * @param string $shopJurFace
     * @return \StructType\RegisterChildInternetShop
     */
    public function setShopJurFace($shopJurFace = null)
    {
        // validation for constraint: string
        if (!is_null($shopJurFace) && !is_string($shopJurFace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shopJurFace, true), gettype($shopJurFace)), __LINE__);
        }
        $this->shopJurFace = $shopJurFace;
        return $this;
    }
    /**
     * Get shopPhone value
     * @return string|null
     */
    public function getShopPhone()
    {
        return $this->shopPhone;
    }
    /**
     * Set shopPhone value
     * @param string $shopPhone
     * @return \StructType\RegisterChildInternetShop
     */
    public function setShopPhone($shopPhone = null)
    {
        // validation for constraint: string
        if (!is_null($shopPhone) && !is_string($shopPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shopPhone, true), gettype($shopPhone)), __LINE__);
        }
        $this->shopPhone = $shopPhone;
        return $this;
    }
    /**
     * Get textReceipt value
     * @return string|null
     */
    public function getTextReceipt()
    {
        return $this->textReceipt;
    }
    /**
     * Set textReceipt value
     * @param string $textReceipt
     * @return \StructType\RegisterChildInternetShop
     */
    public function setTextReceipt($textReceipt = null)
    {
        // validation for constraint: string
        if (!is_null($textReceipt) && !is_string($textReceipt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($textReceipt, true), gettype($textReceipt)), __LINE__);
        }
        $this->textReceipt = $textReceipt;
        return $this;
    }
    /**
     * Get receiverID value
     * @return string|null
     */
    public function getReceiverID()
    {
        return $this->receiverID;
    }
    /**
     * Set receiverID value
     * @param string $receiverID
     * @return \StructType\RegisterChildInternetShop
     */
    public function setReceiverID($receiverID = null)
    {
        // validation for constraint: string
        if (!is_null($receiverID) && !is_string($receiverID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiverID, true), gettype($receiverID)), __LINE__);
        }
        $this->receiverID = $receiverID;
        return $this;
    }
    /**
     * Get Auth value
     * @return \StructType\Authentication|null
     */
    public function getAuth()
    {
        return $this->Auth;
    }
    /**
     * Set Auth value
     * @param \StructType\Authentication $auth
     * @return \StructType\RegisterChildInternetShop
     */
    public function setAuth(\StructType\Authentication $auth = null)
    {
        $this->Auth = $auth;
        return $this;
    }
    /**
     * Get shopINN value
     * @return string|null
     */
    public function getShopINN()
    {
        return $this->shopINN;
    }
    /**
     * Set shopINN value
     * @param string $shopINN
     * @return \StructType\RegisterChildInternetShop
     */
    public function setShopINN($shopINN = null)
    {
        // validation for constraint: string
        if (!is_null($shopINN) && !is_string($shopINN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shopINN, true), gettype($shopINN)), __LINE__);
        }
        $this->shopINN = $shopINN;
        return $this;
    }
    /**
     * Get phoneForCheck value
     * @return string|null
     */
    public function getPhoneForCheck()
    {
        return $this->phoneForCheck;
    }
    /**
     * Set phoneForCheck value
     * @param string $phoneForCheck
     * @return \StructType\RegisterChildInternetShop
     */
    public function setPhoneForCheck($phoneForCheck = null)
    {
        // validation for constraint: string
        if (!is_null($phoneForCheck) && !is_string($phoneForCheck)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phoneForCheck, true), gettype($phoneForCheck)), __LINE__);
        }
        $this->phoneForCheck = $phoneForCheck;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RegisterChildInternetShop
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
